﻿using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;

namespace TreeViewInComboBox
{
	public class TreeViewCombo
	{
		public static object GetSelectedItem(DependencyObject obj)
		{
			return (object)obj.GetValue(SelectedItemProperty);
		}

		public static void SetSelectedItem(DependencyObject obj, object value)
		{
			obj.SetValue(SelectedItemProperty, value);
		}

		public static readonly DependencyProperty SelectedItemProperty =
			DependencyProperty.RegisterAttached("SelectedItem", typeof(object), typeof(TreeViewCombo), null);


		public static bool GetSynchronizeWithOuterComboBox(DependencyObject obj)
		{
			return (bool)obj.GetValue(SynchronizeWithOuterComboBoxProperty);
		}

		public static void SetSynchronizeWithOuterComboBox(DependencyObject obj, bool value)
		{
			obj.SetValue(SynchronizeWithOuterComboBoxProperty, value);
		}

		public static readonly DependencyProperty SynchronizeWithOuterComboBoxProperty =
			DependencyProperty.RegisterAttached("SynchronizeWithOuterComboBox", typeof(bool), typeof(TreeViewCombo), new PropertyMetadata(OnSynchronizeWithOuterComboBoxChanged));


		private static void OnSynchronizeWithOuterComboBoxChanged(DependencyObject d, DependencyPropertyChangedEventArgs args)
		{
			(d as RadTreeView).SelectionChanged += TreeViewCombo_SelectionChanged;
		}

		private static void TreeViewCombo_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			RadTreeView treeView = sender as RadTreeView;
			RadComboBox comboBox = treeView.TemplatedParent as RadComboBox;

			SetSelectedItem(comboBox, treeView.SelectedItem);
			comboBox.IsDropDownOpen = false;
		}
	}
}