﻿using System.Windows;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace TreeViewInComboBox
{
	public class TreeViewCombo : RadComboBox
	{
		static TreeViewCombo()
		{
			EventManager.RegisterClassHandler(typeof(TreeViewCombo), 
				RadTreeView.SelectionChangedEvent, 
				new SelectionChangedEventHandler(OnSelectedTreeViewItemChanged));
		}

		public object SelectedTreeViewItem
		{
			get { return (object)GetValue(SelectedTreeViewItemProperty); }
			set { SetValue(SelectedTreeViewItemProperty, value); }
		}

		public static readonly DependencyProperty SelectedTreeViewItemProperty =
			DependencyProperty.Register("SelectedTreeViewItem", typeof(object), typeof(TreeViewCombo), null);

		private static void OnSelectedTreeViewItemChanged(object sender, SelectionChangedEventArgs e)
		{
			(sender as TreeViewCombo).IsDropDownOpen = false;
			(sender as TreeViewCombo).SelectedTreeViewItem = e.AddedItems.Count == 0 ? null : e.AddedItems[0];
		}
	}
}